Loading...
Searching...
No Matches
juce::SystemStats Class Referencefinal

`#include <juce_SystemStats.h>`

## Public Types

enum

OperatingSystemType {
UnknownOS = 0 , MacOSX = 0x0100 , Windows = 0x0200 , Linux = 0x0400 ,
Android = 0x0800 , iOS = 0x1000 , WASM = 0x2000 , MacOSX_10_7 = MacOSX | 7 ,
MacOSX_10_8 = MacOSX | 8 , MacOSX_10_9 = MacOSX | 9 , MacOSX_10_10 = MacOSX | 10 , MacOSX_10_11 = MacOSX | 11 ,
MacOSX_10_12 = MacOSX | 12 , MacOSX_10_13 = MacOSX | 13 , MacOSX_10_14 = MacOSX | 14 , MacOSX_10_15 = MacOSX | 15 ,
MacOS_11 = MacOSX | 16 , MacOS_12 = MacOSX | 17 , MacOS_13 = MacOSX | 18 , MacOS_14 = MacOSX | 19 ,
Win2000 = Windows | 1 , WinXP = Windows | 2 , WinVista = Windows | 3 , Windows7 = Windows | 4 ,
Windows8_0 = Windows | 5 , Windows8_1 = Windows | 6 , Windows10 = Windows | 7 , Windows11 = Windows | 8
}

enum class | MachineIdFlags { macAddresses = 1 << 0 , fileSystemId = 1 << 1 , legacyUniqueId = 1 << 2 , uniqueId = 1 << 3 }
using | CrashHandlerFunction = void (*) (void*)

## Static Public Member Functions

static String | getJUCEVersion ()
static OperatingSystemType | getOperatingSystemType ()
static String | getOperatingSystemName ()
static bool | isOperatingSystem64Bit ()
static String | getEnvironmentVariable (const String &name, const String &defaultValue)
static String | getLogonName ()
static String | getFullUserName ()
static String | getComputerName ()
static String | getUserLanguage ()
static String | getUserRegion ()
static String | getDisplayLanguage ()
static String | getDeviceDescription ()
static String | getDeviceManufacturer ()
static StringArray | getDeviceIdentifiers ()
static String | getUniqueDeviceID ()
static StringArray | getMachineIdentifiers (MachineIdFlags flags)
static int | getNumCpus () noexcept
static int | getNumPhysicalCpus () noexcept
static int | getCpuSpeedInMegahertz ()
static String | getCpuVendor ()
static String | getCpuModel ()
static bool | hasMMX () noexcept
static bool | has3DNow () noexcept
static bool | hasFMA3 () noexcept
static bool | hasFMA4 () noexcept
static bool | hasSSE () noexcept
static bool | hasSSE2 () noexcept
static bool | hasSSE3 () noexcept
static bool | hasSSSE3 () noexcept
static bool | hasSSE41 () noexcept
static bool | hasSSE42 () noexcept
static bool | hasAVX () noexcept
static bool | hasAVX2 () noexcept
static bool | hasAVX512F () noexcept
static bool | hasAVX512BW () noexcept
static bool | hasAVX512CD () noexcept
static bool | hasAVX512DQ () noexcept
static bool | hasAVX512ER () noexcept
static bool | hasAVX512IFMA () noexcept
static bool | hasAVX512PF () noexcept
static bool | hasAVX512VBMI () noexcept
static bool | hasAVX512VL () noexcept
static bool | hasAVX512VPOPCNTDQ () noexcept
static bool | hasNeon () noexcept
static int | getMemorySizeInMegabytes ()
static int | getPageSize ()
static String | getStackBacktrace ()
static void | setApplicationCrashHandler (CrashHandlerFunction)
static bool | isRunningInAppExtensionSandbox () noexcept
static int | getCpuSpeedInMegaherz ()

## Detailed Description

Contains methods for finding out about the current hardware and OS configuration.

Definition at line 32 of file juce_SystemStats.h.

## Member Typedef Documentation

## CrashHandlerFunction

using juce::SystemStats::CrashHandlerFunction = void (*) (void*)

A function type for use in setApplicationCrashHandler(). When called, its void* argument will contain platform-specific data about the crash.

Definition at line 263 of file juce_SystemStats.h.

## Member Enumeration Documentation

## MachineIdFlags

enum class juce::SystemStats::MachineIdFlags

strong

Kinds of identifier that are passed to getMachineIdentifiers().

Enumerator
macAddresses | All Mac addresses of the machine.
fileSystemId | The filesystem id of the user's home directory (or system directory on Windows).
legacyUniqueId | Only implemented on Windows. A hash of the full smbios table, may be unstable on certain machines.
uniqueId | The most stable kind of machine identifier. A good default to use.

Definition at line 168 of file juce_SystemStats.h.

## OperatingSystemType

enum juce::SystemStats::OperatingSystemType

The set of possible results of the getOperatingSystemType() method.

Enumerator
MacOSX | To test whether any version of OSX is running, you can use the expression ((getOperatingSystemType() & MacOSX) != 0).
Windows | To test whether any version of Windows is running, you can use the expression ((getOperatingSystemType() & Windows) != 0).

Definition at line 43 of file juce_SystemStats.h.

## Member Function Documentation

## getComputerName()

String juce::SystemStats::getComputerName | ( |  | ) |

static

Returns the host-name of the computer.

## getCpuModel()

String juce::SystemStats::getCpuModel | ( |  | ) |

static

Attempts to return a string describing the CPU model. May not be available on some systems.

Referenced by getCpuModel().

## getCpuSpeedInMegahertz()

int juce::SystemStats::getCpuSpeedInMegahertz | ( |  | ) |

static

Returns the approximate CPU speed.

Returns
  the speed in megahertz, e.g. 1500, 2500, 32000 (depending on what year you're reading this...)

Referenced by getCpuSpeedInMegahertz().

## getCpuSpeedInMegaherz()

int juce::SystemStats::getCpuSpeedInMegaherz | ( |  | ) |

inline static

Definition at line 285 of file juce_SystemStats.h.

## getCpuVendor()

String juce::SystemStats::getCpuVendor | ( |  | ) |

static

Returns a string to indicate the CPU vendor. Might not be known on some systems.

Referenced by getCpuVendor().

## getDeviceDescription()

String juce::SystemStats::getDeviceDescription | ( |  | ) |

static

This will attempt to return some kind of string describing the device. If no description is available, it'll just return an empty string. You may want to use this for things like determining the type of phone/iPad, etc.

## getDeviceIdentifiers()

StringArray juce::SystemStats::getDeviceIdentifiers | ( |  | ) |

static

This method calculates some IDs to uniquely identify the device.

The first choice for an ID is a filesystem ID for the user's home folder or windows directory. If that fails then this function returns the MAC addresses.

Definition at line 61 of file juce_SystemStats.cpp.

Referenced by getDeviceManufacturer().

## getDeviceManufacturer()

String juce::SystemStats::getDeviceManufacturer | ( |  | ) |

static

This will attempt to return the manufacturer of the device. If no description is available, it'll just return an empty string.

## getDisplayLanguage()

String juce::SystemStats::getDisplayLanguage | ( |  | ) |

static

Returns the user's display language. The return value is a 2 or 3 letter language code (ISO 639-1 or ISO 639-2). Note that depending on the OS and region, this may also be followed by a dash and a sub-region code, e.g "en-GB"

## getEnvironmentVariable()

String juce::SystemStats::getEnvironmentVariable | ( | const String & | name,
|  | const String & | defaultValue )

static

Returns an environment variable. If the named value isn't set, this will return the defaultValue string instead.

## getFullUserName()

String juce::SystemStats::getFullUserName | ( |  | ) |

static

Returns the current user's full name, if available. On some OSes, this may just return the same value as getLogonName().

See also
  getLogonName()

## getJUCEVersion()

String juce::SystemStats::getJUCEVersion | ( |  | ) |

static

Returns the current version of JUCE, See also the JUCE_VERSION, JUCE_MAJOR_VERSION and JUCE_MINOR_VERSION macros.

Definition at line 26 of file juce_SystemStats.cpp.

## getLogonName()

String juce::SystemStats::getLogonName | ( |  | ) |

static

Returns the current user's name, if available.

See also
  getFullUserName()

## getMachineIdentifiers()

StringArray juce::SystemStats::getMachineIdentifiers | ( | MachineIdFlags | flags | ) |

static

Returns a list of strings that can be used to uniquely identify a machine.

To get multiple kinds of identifier at once, you can combine flags using bitwise-or, e.g. uniqueId | legacyUniqueId.

If a particular kind of identifier isn't available, it will be omitted from the StringArray of results, so passing uniqueId | legacyUniqueId may return 0, 1, or 2 results, depending on the platform and whether any errors are encountered.

If you've previously generated a machine ID and just want to check it against all possible identifiers, you can enable all of the flags and check whether the stored identifier matches any of the results.

Definition at line 73 of file juce_SystemStats.cpp.

Referenced by getDeviceIdentifiers().

## getMemorySizeInMegabytes()

int juce::SystemStats::getMemorySizeInMegabytes | ( |  | ) |

static

Finds out how much RAM is in the machine.

Returns
  the approximate number of megabytes of memory, or zero if something goes wrong when finding out.

Referenced by getMemorySizeInMegabytes().

## getNumCpus()

int juce::SystemStats::getNumCpus | ( |  | ) |

static noexcept

Returns the number of logical CPU cores.

Definition at line 149 of file juce_SystemStats.cpp.

## getNumPhysicalCpus()

int juce::SystemStats::getNumPhysicalCpus | ( |  | ) |

static noexcept

Returns the number of physical CPU cores.

Definition at line 150 of file juce_SystemStats.cpp.

## getOperatingSystemName()

String juce::SystemStats::getOperatingSystemName | ( |  | ) |

static

Returns the name of the type of operating system we're running on.

Returns
  a string describing the OS type.

See also
  getOperatingSystemType

## getOperatingSystemType()

OperatingSystemType juce::SystemStats::getOperatingSystemType | ( |  | ) |

static

Returns the type of operating system we're running on.

Returns
  one of the values from the OperatingSystemType enum.

See also
  getOperatingSystemName

Referenced by juce::ChildProcessCoordinator::launchWorkerProcess().

## getPageSize()

int juce::SystemStats::getPageSize | ( |  | ) |

static

Returns the system page-size. This is only used by programmers with beards.

Referenced by getPageSize().

## getStackBacktrace()

String juce::SystemStats::getStackBacktrace | ( |  | ) |

static

Returns a backtrace of the current call-stack. The usefulness of the result will depend on the level of debug symbols that are available in the executable.

Definition at line 177 of file juce_SystemStats.cpp.

Referenced by getPageSize().

## getUniqueDeviceID()

String juce::SystemStats::getUniqueDeviceID | ( |  | ) |

static

This method returns a machine unique ID unaffected by storage or peripheral changes.

This ID will be invalidated by changes to the motherboard and CPU on non-mobile platforms, or performing a system restore on an Android device.

There are some extra caveats on iOS: The returned ID is unique to the vendor part of your 'Bundle Identifier' and is stable for all associated apps. The key is invalidated once all associated apps are uninstalled. This function can return an empty string under certain conditions, for example, If the device has not been unlocked since a restart.

Referenced by getMachineIdentifiers().

## getUserLanguage()

String juce::SystemStats::getUserLanguage | ( |  | ) |

static

Returns the language of the user's locale. The return value is a 2 or 3 letter language code (ISO 639-1 or ISO 639-2)

## getUserRegion()

String juce::SystemStats::getUserRegion | ( |  | ) |

static

Returns the region of the user's locale. The return value is a 2 letter country code (ISO 3166-1 alpha-2).

## has3DNow()

bool juce::SystemStats::has3DNow | ( |  | ) |

static noexcept

Returns true if AMD 3DNOW instructions are available.

Definition at line 152 of file juce_SystemStats.cpp.

Referenced by getCpuModel().

## hasAVX()

bool juce::SystemStats::hasAVX | ( |  | ) |

static noexcept

Returns true if Intel AVX instructions are available.

Definition at line 161 of file juce_SystemStats.cpp.

Referenced by getCpuModel().

## hasAVX2()

bool juce::SystemStats::hasAVX2 | ( |  | ) |

static noexcept

Returns true if Intel AVX2 instructions are available.

Definition at line 162 of file juce_SystemStats.cpp.

Referenced by getCpuModel().

## hasAVX512BW()

bool juce::SystemStats::hasAVX512BW | ( |  | ) |

static noexcept

Returns true if Intel AVX-512 Byte and Word instructions are available.

Definition at line 164 of file juce_SystemStats.cpp.

Referenced by getCpuModel().

## hasAVX512CD()

bool juce::SystemStats::hasAVX512CD | ( |  | ) |

static noexcept

Returns true if Intel AVX-512 Conflict Detection instructions are available.

Definition at line 165 of file juce_SystemStats.cpp.

Referenced by getCpuModel().

## hasAVX512DQ()

bool juce::SystemStats::hasAVX512DQ | ( |  | ) |

static noexcept

Returns true if Intel AVX-512 Doubleword and Quadword instructions are available.

Definition at line 166 of file juce_SystemStats.cpp.

Referenced by getCpuModel().

## hasAVX512ER()

bool juce::SystemStats::hasAVX512ER | ( |  | ) |

static noexcept

Returns true if Intel AVX-512 Exponential and Reciprocal instructions are available.

Definition at line 167 of file juce_SystemStats.cpp.

Referenced by getCpuModel().

## hasAVX512F()

bool juce::SystemStats::hasAVX512F | ( |  | ) |

static noexcept

Returns true if Intel AVX-512 Foundation instructions are available.

Definition at line 163 of file juce_SystemStats.cpp.

Referenced by getCpuModel().

## hasAVX512IFMA()

bool juce::SystemStats::hasAVX512IFMA | ( |  | ) |

static noexcept

Returns true if Intel AVX-512 Integer Fused Multiply-Add instructions are available.

Definition at line 168 of file juce_SystemStats.cpp.

Referenced by getCpuModel().

## hasAVX512PF()

bool juce::SystemStats::hasAVX512PF | ( |  | ) |

static noexcept

Returns true if Intel AVX-512 Prefetch instructions are available.

Definition at line 169 of file juce_SystemStats.cpp.

Referenced by getCpuModel().

## hasAVX512VBMI()

bool juce::SystemStats::hasAVX512VBMI | ( |  | ) |

static noexcept

Returns true if Intel AVX-512 Vector Bit Manipulation instructions are available.

Definition at line 170 of file juce_SystemStats.cpp.

Referenced by getCpuModel().

## hasAVX512VL()

bool juce::SystemStats::hasAVX512VL | ( |  | ) |

static noexcept

Returns true if Intel AVX-512 Vector Length instructions are available.

Definition at line 171 of file juce_SystemStats.cpp.

Referenced by getCpuModel().

## hasAVX512VPOPCNTDQ()

bool juce::SystemStats::hasAVX512VPOPCNTDQ | ( |  | ) |

static noexcept

Returns true if Intel AVX-512 Vector Population Count Double and Quad-word instructions are available.

Definition at line 172 of file juce_SystemStats.cpp.

Referenced by getCpuModel().

## hasFMA3()

bool juce::SystemStats::hasFMA3 | ( |  | ) |

static noexcept

Returns true if AMD FMA3 instructions are available.

Definition at line 153 of file juce_SystemStats.cpp.

Referenced by getCpuModel().

## hasFMA4()

bool juce::SystemStats::hasFMA4 | ( |  | ) |

static noexcept

Returns true if AMD FMA4 instructions are available.

Definition at line 154 of file juce_SystemStats.cpp.

Referenced by getCpuModel().

## hasMMX()

bool juce::SystemStats::hasMMX | ( |  | ) |

static noexcept

Returns true if Intel MMX instructions are available.

Definition at line 151 of file juce_SystemStats.cpp.

Referenced by getCpuModel().

## hasNeon()

bool juce::SystemStats::hasNeon | ( |  | ) |

static noexcept

Returns true if ARM NEON instructions are available.

Definition at line 173 of file juce_SystemStats.cpp.

Referenced by getCpuModel().

## hasSSE()

bool juce::SystemStats::hasSSE | ( |  | ) |

static noexcept

Returns true if Intel SSE instructions are available.

Definition at line 155 of file juce_SystemStats.cpp.

Referenced by getCpuModel().

## hasSSE2()

bool juce::SystemStats::hasSSE2 | ( |  | ) |

static noexcept

Returns true if Intel SSE2 instructions are available.

Definition at line 156 of file juce_SystemStats.cpp.

Referenced by getCpuModel().

## hasSSE3()

bool juce::SystemStats::hasSSE3 | ( |  | ) |

static noexcept

Returns true if Intel SSE3 instructions are available.

Definition at line 157 of file juce_SystemStats.cpp.

Referenced by getCpuModel().

## hasSSE41()

bool juce::SystemStats::hasSSE41 | ( |  | ) |

static noexcept

Returns true if Intel SSE4.1 instructions are available.

Definition at line 159 of file juce_SystemStats.cpp.

Referenced by getCpuModel().

## hasSSE42()

bool juce::SystemStats::hasSSE42 | ( |  | ) |

static noexcept

Returns true if Intel SSE4.2 instructions are available.

Definition at line 160 of file juce_SystemStats.cpp.

Referenced by getCpuModel().

## hasSSSE3()

bool juce::SystemStats::hasSSSE3 | ( |  | ) |

static noexcept

Returns true if Intel SSSE3 instructions are available.

Definition at line 158 of file juce_SystemStats.cpp.

Referenced by getCpuModel().

## isOperatingSystem64Bit()

bool juce::SystemStats::isOperatingSystem64Bit | ( |  | ) |

static

Returns true if the OS is 64-bit, or false for a 32-bit OS.

## isRunningInAppExtensionSandbox()

bool juce::SystemStats::isRunningInAppExtensionSandbox | ( |  | ) |

static noexcept

Returns true if this code is running inside an app extension sandbox. This function will always return false on windows, linux and android.

Definition at line 270 of file juce_SystemStats.cpp.

## setApplicationCrashHandler()

void juce::SystemStats::setApplicationCrashHandler | ( | CrashHandlerFunction | handler | ) |

static

Sets up a global callback function that will be called if the application executes some kind of illegal instruction.

You may want to call getStackBacktrace() in your handler function, to find out where the problem happened and log it, etc.

Definition at line 250 of file juce_SystemStats.cpp.

The documentation for this class was generated from the following files:

- juce_SystemStats.h
- juce_SystemStats.cpp